#!/usr/bin/env bash

set -o errexit
set -o nounset
set -o pipefail
if [[ "${TRACE-0}" == "1" ]]; then
  set -o xtrace
fi

cd "$(dirname "$0")"

main ()
{
  declare -a components
  declare -i result=0
  while read -r line; do
    mapfile -t matches <<< "$(grep -o '[[:digit:]]' <<< "${line}")"
    components+=("${matches[0]}${matches[-1]}")
  done < input.txt
  for value in "${components[@]}"; do
    (( result += value ))
  done
  echo "${result}"
}

main
